	device zxspectrum128
;        ORG #4000
; incbin "comp.scr"
        ORG #6000
begin
;	ld hl,$5800,de,$5803,bc,765:set 6,(hl):ldir
	ld hl,tud,de,$4000:call dzx7_standard
	ld hl,song:call INIT
	di
	ld hl,$BE00,de,$be01,bc,257,(hl),$BF
	ldir
	ld a,$be,i,a
	im 2
	ld a,$C3,($BFBF),a
	ld hl,intvec,($BFBF+1),hl
	ei
Tunnel
	ld a,5
	ld (_move_depth+1),a
	ld a,1
	ld (_move_angle+1),a	
_loop
	; Set y-increment mode (increments X)
;	ld a,$07
;	call safe_lcd_pause
;	out ($10),a
	
	ld a,(_gs_dither+1)
	xor $FF
	ld (_gs_dither+1),a
	
	ld a,$C6
	ld (_angle_switch_positive+1),a
	ld a,$D6
	ld (_angle_switch_negative+1),a
	ld a,$CA
	ld (_colour_switch_z+1),a
	ld a,$C2
	ld (_colour_switch_nz+1),a

	ld hl,49
	ld (_dir_through_lookup_a+1),hl
	ld (_dir_through_lookup_d+1),hl

_depth_table_location
	ld hl,_depths
_angle_table_location
	ld de,_angles
	
	ld a,$80
	ld (_set_y_offset+1),a

	exx
	ld hl,tud ;$4805
	exx
_next_row

	ld a,$23	; INC HL
	ld (_lut_a_offset),a

	ld a,$13	; INC DE
	ld (_lut_d_offset),a
_angle_switch_positive:
	ld a,$C6	; ADD A,*
	ld (_view_angle),a

_colour_switch_z
	ld a,$CA	; JP Z
	ld (_branch_mode_light),a
	ld (_branch_mode_dark),a

;	ld a,$20
;	out ($10),a
_set_y_offset
	ld a,$80
;	call safe_lcd_pause
;	out ($10),a

	ld b,12
;	exx
;	push hl
;	exx
_row_loop
	ld ixl,0
	ld c,%10000000
	
_build_up_data_byte

	ld a,(de)
_lut_d_offset
	inc de

_view_angle
	add a,$00
	ld (_to_xor+1),a
	ld a,(hl)
_lut_a_offset
	inc hl
_view_depth
	add a,$00

_to_xor
	xor $00	
	
	bit 5,a
_branch_mode_light
	jp z,_no_draw_at_all

	
	bit 3,a
_branch_mode_dark
	jp z,_draw_full_black

_draw_grey
	ld a,c
_gs_dither
	and %10101010
	jp z,_no_draw_at_all

_draw_full_black

	ld a,ixl
	or c
	ld ixl,a
_no_draw_at_all
	srl c
	jp nc,_build_up_data_byte
	
	; Write to LCD:
	ld a,ixl

	exx
	ld (hl),a
	inc hl
	exx

;	out ($11),a

	ld a,b
	cp 7	; Do we need to start moving BACKWARDS on our table?
	jp nz,br1;{+}
	ld a,$2B	; DEC HL
	ld (_lut_a_offset),a
	ld a,$1B	; DEC DE
	ld (_lut_d_offset),a
_angle_switch_negative
	ld a,$D6	; SUB *
	ld (_view_angle),a
_colour_switch_nz
	ld a,$C2	; JP NZ
	ld (_branch_mode_light),a
	ld (_branch_mode_dark),a	
	dec hl
	dec de
br1;+
	
	djnz _row_loop
	
;	exx
;	pop hl
;	call nbhl
;	exx

	ld a,(_gs_dither+1)
	xor $FF
	ld (_gs_dither+1),a
	
	; Move down a row
	ld a,(_set_y_offset+1)
	inc a
	cp $80+32
	jp nz,_not_half_way
	
	; We are now half-way, so let's flip the directions...
	

	ld (_set_y_offset+1),a	
	push hl
	ld hl,-47
	ld (_dir_through_lookup_a+1),hl
	ld (_dir_through_lookup_d+1),hl
	pop hl

	ld a,$D6
	ld (_angle_switch_positive+1),a
	ld a,$C6
	ld (_angle_switch_negative+1),a
	ld a,$C2
	ld (_colour_switch_z+1),a
	ld a,$CA
	ld (_colour_switch_nz+1),a	

	inc hl
	inc de
	jp _next_row

_not_half_way
	cp $80+64
	jp z,_finished_frame
	ld (_set_y_offset+1),a	
	
	; Move pointers up/down a row
	
	push de
_dir_through_lookup_a
	ld de,49
	add hl,de
	pop de
	
	push hl
_dir_through_lookup_d
	ld hl,49
	add hl,de
	ld d,h
	ld e,l
	pop hl
	
	
	jp _next_row
_finished_frame

	; Update the angle/depth offsets
	ld a,(_view_angle+1)
_move_angle
	add a,1
	ld (_view_angle+1),a
	
	ld a,(_view_depth+1)
_move_depth
	add a,1
	ld (_view_depth+1),a
	
	; Now handle directional keypresses (uses direct input)
	
;	ld a,$FF
;	out (1),a
;	ld a,KeyRow_Pad
;	out (1),a
;	in a,(1)
;	ld a,5
	ld hl,_move_angle+1
	bit 1,a
	jr nz,br2;{+}

	inc (hl)
;+	bit 2,a
br2	bit 2,a
	jr nz,br3;{+}
	dec (hl)
;+	
br3
	ld hl,_move_depth+1
	bit 3,a
	jr nz,br4;{+}
	inc (hl)
;+	bit 0,a
br4	bit 0,a
	jr nz,br5;{+}
	dec (hl)
br5;+
	; Branch back to the main loop.
	ei:halt
	ld a,64
	ld hl,tud
	ld de,$4805
cpy:
	exa
	push de
 dup 12
 ldi
 edup
 	pop de
 	call nbde
	exa
	dec a
	jp nz,cpy
;	call scene_countdown
	jp _loop
nbde    INC D:LD A,D:AND 7:RET NZ
        LD A,E:ADD A,#20:LD E,A:RET C
        LD A,D:SUB 8:LD D,A:RET

screen_adr equ #50ff;screen adress for output
scroll:
 ld hl,screen_adr
 ld b,8
scroll_text:
 push hl
 xor a

 dup 32;unroll cycle
 rl(hl)
 dec l
edup

 pop hl
 inc h
 dec b
 jp nz,scroll_text

;out text, IX: string with limiter 0
scrp:ld ix,scrtxt
 ld a,(ix)
 or a
 jr nz,noloop
;if zero loop text again
 ld ix,scrtxt
 ld a,(ix)
noloop:ld (scrp+2),ix

 ld de,screen_adr
 ld l,a,h,0; calculate adress ROM font
 
 add hl,hl;ascii*8
 add hl,hl
 add hl,hl
 ld bc,fnt;$3C00;ROM font
 add hl,bc
 ex de,hl


 ld b,8;one loop for letter
letrlp:
 ld a,(de)
bw:and #80
 jr z,nobit
 set 0,(hl)
nobit:
 inc de,h
 djnz letrlp

 ld a,(bw+1)
 or a
 rrca
 ld (bw+1),a
 ret nc

 ld hl,(scrp+2)
 inc hl
 ld (scrp+2),hl
 ret
scrtxt:; db "*simple scroll* "
 db "Whoa! what a hell is going on the screen?"
 db "This is simple calculating tunnel effect."
 db "There are no fucks and greets cause scene sleeps."
 db "See you later, bye-bye! g0blinish,13-05-2o2o                              "
 db 0
fnt:incbin "cga.002"
_depths incbin "depth.lut"
_angles incbin "angles.lut"
zx7:include "zx7.a80"

intvec:
	push ix,iy
	push hl,de,bc,af
	exx:exa
	push hl,de,bc,af
	call scroll
	CALL PLAY
	pop af,bc,de,hl
	exx:exa
	pop af,bc,de,hl
	pop iy,ix
	ei:ret
song:incbin "000_00018980.pt3"
ply:include "PTxPlay.a80"
tud:
 incbin "comp.scr.zx7"
end
	display /d,end-begin
	savesna "!void.sna",begin

;-----------------------------------------------------------
 macro	sectors datab,datae

 IF low (datae-datab)=0
   db 1,5,high (datae-datab)
 ELSE
   db 1,5,(1+high (datae-datab))
 ENDIF

	endm

 MODULE boot
Basic:
 db #00,#01; 
 DW EndLine1 - Line1
Line1:
 db #EA;REM
 ld sp,#5FFE

    res 4,(iy+1)
    xor a:out ($FE),a
    ld hl,$5AFF,de,$5AFe,bc,$1B00-1,(hl),0:lddr

;demo
 di
 ld de,(#5CF4)
 ld hl, #6000
 ld a,#10,bc,#7FFD:out (c),a
 sectors begin,end
 call #3d13

 jp #6000


 db "yo,lamer!"
 db #0D
EndLine1:
 db #00,#02
 DW EndLine2 - Line2
Line2:
 db #20,#FD,#B0
 db #22,#32,#34,#35,#37,#35,#22;clear val "24575"
 db #3A; :
 db #F9,#C0,#28,#35;randomize usr (5+256*peek val "23635"+peek val "23636"
 db #0E,#00,#00,#05,#00,#00,#2B
 db #32,#35,#36
 db #0E,#00,#00,#00,#01,#00,#2A,#BE

 db #B0
 db #22,#32,#33,#36,#33,#36,#22;"23635"
 db #2B;???
 db #BE
 db #B0
 db #22,#32,#33,#36,#33,#35,#22;"23636"
 db #29,#0D;)
 db #80
 db #AA,1,0;;;;;;;;;;;;;autorun line,change program length to -4, e.g. 83-4=79
EndLine2:
EndBasic:
 ENDMODULE

	display /d,end-begin

    EMPTYTRD "dust.trd" ;create empty TRD image
	SAVETRD "dust.trd", "vintage.B", boot.Basic, boot.EndBasic - boot.Basic
    SAVETRD "dust.trd","demo.C",begin,end-begin


;-----------------------------------------------------------
